#include "DataProvider.h"

int 
DataProvider::downloadDEM(int i, int j)
{
  char buf[256];
  sprintf(buf, "%s%d%d.dem", urlRoot, i, j);

  info(buf);
  
  (data[i][j]) = new URLDEM(buf);
  (data[i][j])->read();

#ifdef DEBUG
  int ddim = (data[i][j])->dim;
  (data[i][j])->writeRect(0, ddim, 0, ddim, "dem.dem");
#endif //DEBUG

  return 1;
}

DEM *
DataProvider::getDEM(int xPos, int yPos, int dim)
{

  int demSize = (data[xPos][yPos])->dim; 
  int i, j, k, l;
  
  //each dem has one row and column for covering with a neighbor
  
  ELEV **tmp;
  
  NewMatrix(tmp, demSize*dim, demSize*dim, ELEV);
  for(i=0; i<dim; i++)
    for(j=0; j<dim; j++)
      for(k=0; k<demSize; k++)
	for(l=0; l<demSize; l++)
	  tmp[i*demSize+k][j*demSize+l] = (*data[xPos+j][yPos+i])(k,l);

  returnedDEM = new DEM(tmp, demSize*dim);

  delete tmp;

  info("out getDEM");

  return returnedDEM;
  
  //user has to delete it!!
}



